import signal
from comIF.obsw_com_interface import CommunicationInterface


class GracefulKiller:
    kill_now = False

    def __init__(self):
        signal.signal(signal.SIGINT, self.exit_gracefully)
        signal.signal(signal.SIGTERM, self.exit_gracefully)

    def exit_gracefully(self):
        self.kill_now = True
        print("I was killed")


def keyboard_interrupt_handler(comInterface: CommunicationInterface):
    print("Disconnect registered")
    # Unit Test closes Serial Port at the end
    # We could do some optional stuff here
    if comInterface is not None:
        comInterface.send_telecommand(bytearray([0, 0, 0, 0, 0]))
